(* Built-in empty penetrator for Athena.  Include it into the
   user-defined penetrator protocols as their "penetrator" to be able
   to override the default penetrator's roles. *)

functor EmptyPenetratorFun(structure ParseTreeStruct: ATHENA_PARSE_TREE): PENETRATOR =
  struct
    structure ParseTreeStruct = ParseTreeStruct

    open ParseTreeStruct
    open Pos

    val penetratorName = "EmptyPenetrator"

    val penetrator = Protocol(dp, Id(dp, penetratorName), [])
  end
