structure Pos:> POS =
  struct
    type Pos = int * int
    val dp=(~1,~1)

    fun pos2string (l,c) = (Int.toString l)^"."^(Int.toString c)
    fun posRange2string(p1, p2) =
	if p1 = p2 then (pos2string p1)
	else (pos2string p1)^"-"^(pos2string p2)

    fun minPos [] = dp
      | minPos (p::lst) =
	let val p0 as (l0, c0) = minPos lst
	    val (l, c) = p
	in
	    if p = dp then p0
	    else if p0 = dp then p
            else if l < l0 orelse (l = l0 andalso c < c0) then p
	    else p0
	end
		
    fun maxPos [] = dp
      | maxPos (p::lst) =
	let val p0 as (l0, c0) = maxPos lst
	    val (l, c) = p
	in
	    if p = dp then p0
	    else if p0 = dp then p
            else if l > l0 orelse (l = l0 andalso c > c0) then p
	    else p0
	end
		
  end
