(* Common types and objects for all prover instances. *)

functor ProverInterfaceCommonFun(structure Interface: INTERFACE): PROVER_INTERFACE_COMMON =
  struct
    exception ProverError of string
    (* The status of the proof in a prover *)

    datatype ProverStatus = Incomplete | Complete

    structure StatusFile = StatusFileFun(structure Interface = Interface)

  end
